(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untChat.pas                                     ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Chat form                        ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untChat;

interface

uses
  SysUtils, Classes, Controls, Forms, StdCtrls, Buttons, ComCtrls;

type
  TfrmChat = class(TForm)
    EdtNewMsg: TEdit;
    SpdSend: TSpeedButton;
    SpdClose: TSpeedButton;
    RichChat: TRichEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpdCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpdSendClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmChat: TfrmChat;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmChat.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   frmMain.strStatus:='Fermeture du chat...';
   frmMain.SendCommand(COMMAND_CHAT_CLOSE,'');
   Action:=caFree;
   frmChat:=nil;
end;

procedure TfrmChat.SpdCloseClick(Sender: TObject);
begin
   Close;
end;

procedure TfrmChat.FormCreate(Sender: TObject);
begin
   Caption:='Chat avec la victime';
end;

procedure TfrmChat.SpdSendClick(Sender: TObject);
var
   strSend:string;
begin
   if (Trim(EdtNewMsg.Text) = '') then Exit;
   strSend:=frmMain.strNick + ' - ' + EdtNewMsg.Text;
   frmMain.SendCommand(COMMAND_CHAT_MESSAGE,strSend);
   if frmMain.ClientMain.Active then
      RichChat.Lines.Add(strSend);
   EdtNewMsg.Text:='';
end;

end.
