(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untGetSetSettings.pas                           ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Procedures to save/read settings              ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untGetSetSettings;

interface

uses Windows, Registry;

procedure SaveSetting(Key, NewValue:string);
procedure GetSetting(Key:string; var DefValue:string);

implementation

procedure SaveSetting(Key, NewValue:string);
var
   Reg:TRegistry;
begin
   Reg:=TRegistry.Create;
   Reg.RootKey:=HKEY_LOCAL_MACHINE;
   Reg.OpenKey('Software\Latinus',True);
   Reg.WriteString(Key,NewValue);
   Reg.CloseKey;
   Reg.Free;
end;

procedure GetSetting(Key:string; var DefValue:string);
var
   Reg:TRegistry;
begin
   Reg:=TRegistry.Create;
   Reg.RootKey:=HKEY_LOCAL_MACHINE;
   Reg.OpenKey('Software\Latinus',True);
   if Reg.ValueExists(Key) then
      DefValue:=Reg.ReadString(Key);
   Reg.CloseKey;
   Reg.Free;
end;

end.
