(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untMouse.pas                                    ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Mouse form                       ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untMouse;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls,
  Buttons, Spin;

type
  TfrmMouse = class(TForm)
    SpdActCrazy: TSpeedButton;
    SpdReverse: TSpeedButton;
    SpdRestore: TSpeedButton;
    SpdDeactCrazy: TSpeedButton;
    SpdUnlockMouse: TSpeedButton;
    SpdLockMouse: TSpeedButton;
    GruMove: TGroupBox;
    SpdStartMove: TSpeedButton;
    SpdStopMove: TSpeedButton;
    GruSpeed: TGroupBox;
    SpdSetSpeed: TSpeedButton;
    SpdReadSpeed: TSpeedButton;
    SpnSpeed: TSpinEdit;
    procedure SpdReverseClick(Sender: TObject);
    procedure SpdActCrazyClick(Sender: TObject);
    procedure SpdLockMouseClick(Sender: TObject);
    procedure SpdReadSpeedClick(Sender: TObject);
    procedure SpdSetSpeedClick(Sender: TObject);
    procedure SpdStartMoveClick(Sender: TObject);
    procedure SpdStopMoveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    function DoPoint:string;
  end;

var
  frmMouse: TfrmMouse;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmMouse.SpdReverseClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de restorers...';
   frmMain.SendCommand(COMMAND_REVERSE_BUTTONS,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmMouse.SpdActCrazyClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de ' + LowerCase(TSpeedButton(Sender).Caption) + '...';
   frmMain.SendCommand(COMMAND_CRAZY_MOUSE,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmMouse.SpdLockMouseClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de ' + LowerCase(TSpeedButton(Sender).Caption) + '...';
   frmMain.SendCommand(COMMAND_LOCK_MOUSE,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmMouse.SpdReadSpeedClick(Sender: TObject);
begin
   frmMain.strStatus:='Lecture de la vitesse...';
   frmMain.SendCommand(COMMAND_GET_DBL_TIME,'');
end;

procedure TfrmMouse.SpdSetSpeedClick(Sender: TObject);
begin
   frmMain.strStatus:='Changement de la vitesse...';
   frmMain.SendCommand(COMMAND_SET_DBL_TIME,Trim(SpnSpeed.Text));
end;

procedure TfrmMouse.SpdStartMoveClick(Sender: TObject);
begin
   frmMain.strStatus:='Dmarage mouvement...';
   frmMain.SendCommand(COMMAND_SET_MOUSE_POS,DoPoint);
   frmMain.boolMov:=frmMain.ClientMain.Active;
end;

procedure TfrmMouse.SpdStopMoveClick(Sender: TObject);
begin
   if frmMain.ClientMain.Active then
      frmMain.PutStatus('Stop mouvement...')
   else
      frmMain.PutStatus('PAS CONNECT!...');
   frmMain.boolMov:=False;
end;

function TfrmMouse.DoPoint:string;
var
   Pnt:TPoint;
   tmpR:string;
begin
   GetCursorPos(Pnt);
   tmpR:=Format('%d,%d',[Pnt.X,Pnt.Y]);
   frmMain.PutStatus('Dplacer la sourrie : ' + tmpR);
   DoPoint:=tmpR;
end;

procedure TfrmMouse.FormCreate(Sender: TObject);
begin
   Caption:='Sourrie';
end;

end.
