(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untOpenChat.pas                                 ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of OpenChat form                    ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untOpenChat;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls,
  Buttons, ExtCtrls, Spin;

type
  TfrmOpenChat = class(TForm)
    PntChat: TPanel;
    LblChat4: TLabel;
    LblChat3: TLabel;
    LblChat1: TLabel;
    SpdOpenChat: TSpeedButton;
    EdtNickName: TEdit;
    SpnSize: TSpinEdit;
    procedure SpdOpenChatClick(Sender: TObject);
    function CanOpenChat:Boolean;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOpenChat: TfrmOpenChat;

implementation

uses untMain, untCommands, untChat;
{$R *.DFM}

procedure TfrmOpenChat.SpdOpenChatClick(Sender: TObject);
begin
   if CanOpenChat then
   begin
      if frmMain.ClientMain.Active then
         frmMain.strNick:=EdtNickName.Text;
      frmMain.strStatus:='Ouverture du Chat...';
      frmMain.SendCommand(COMMAND_CHAT_OPEN,Trim(SpnSize.Text));
      if frmChat = nil then
         frmChat:=TfrmChat.Create(Self);
      frmChat.Show;
   end;
end;

function TfrmOpenChat.CanOpenChat:Boolean;
var
   intSize:Integer;
begin
   CanOpenChat:=False;
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('Pas connect...');
      Exit;
   end;
   if Trim(EdtNickName.Text) = '' then
   begin
      MessageBox(handle,'Entrer votre pseudo.',PChar(frmMain.Caption),MB_ICONASTERISK);
      EdtNickName.SetFocus;
      Exit;
   end;
   intSize:=StrToIntDef(Trim(SpnSize.Text),-1);
   if (intSize < 0) or (intSize > 100) or (intSize < 15) then
   begin
      MessageBox(handle,'Valeur invalide (15 a 100).',PChar(frmMain.Caption),MB_ICONASTERISK);
      Exit;
   end;
   CanOpenChat:=True;
end;

procedure TfrmOpenChat.FormCreate(Sender: TObject);
begin
   Caption:='Chat';
end;

end.
