(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untPrinter.pas                                  ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Printer form                     ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untPrinter;

interface

uses
  SysUtils, Classes, Controls, Forms, Buttons,
  ComCtrls, StdCtrls, Graphics, Spin;

type
  TfrmPrinter = class(TForm)
    ChkUnderline: TCheckBox;
    ChkStrike: TCheckBox;
    ChkItalic: TCheckBox;
    ChkBold: TCheckBox;
    RichPrint: TRichEdit;
    Label8: TLabel;
    SpdPrintText: TSpeedButton;
    SpdClear: TSpeedButton;
    SpnFontSize: TSpinEdit;
    procedure GlobalFont(Sender: TObject);
    procedure SpdPrintTextClick(Sender: TObject);
    procedure EdtFontSizeChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpdClearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPrinter: TfrmPrinter;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmPrinter.GlobalFont(Sender: TObject);
var
   Styles:TFontStyles;
   Fs:TFontStyle;
begin
   Styles:=RichPrint.Font.Style;
   Fs:=TFontStyle((Sender as TCheckBox).Tag);
   if (Sender as TCheckBox).Checked then
      Include(Styles,Fs)
   else
      Styles:=Styles - [Fs];
   RichPrint.Font.Style:=Styles;
end;

procedure TfrmPrinter.SpdPrintTextClick(Sender: TObject);
var
   strArgs,c:string;
begin
   c:=Chr(0);
   RichPrint.Text:=StringReplace(RichPrint.Text,c,'',[rfReplaceAll]);
   strArgs:=RichPrint.Text + c + IntToStr(Integer(ChkBold.Checked));
   strArgs:=strArgs + c + IntToStr(Integer(ChkItalic.Checked));
   strArgs:=strArgs + c + IntToStr(Integer(ChkUnderline.Checked));
   strArgs:=strArgs + c + IntToStr(Integer(ChkStrike.Checked));
   strArgs:=strArgs + c + IntToStr(RichPrint.Font.Size);
   frmMain.strStatus:='Impression en cour...';
   frmMain.SendCommand(COMMAND_PRINT_TEXT,strArgs);
end;

procedure TfrmPrinter.EdtFontSizeChange(Sender: TObject);
begin
   RichPrint.Font.Size:=StrToIntDef(Trim(SpnFontSize.Text),8);
end;

procedure TfrmPrinter.FormCreate(Sender: TObject);
begin
   Caption:='Imprimante';
end;

procedure TfrmPrinter.SpdClearClick(Sender: TObject);
begin
   RichPrint.Text:='';
end;

end.
