(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untSettings.pas                                 ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Settings form                    ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untSettings;

interface

uses
  Windows, SysUtils, Controls, Forms, StdCtrls,
  Buttons, Spin, Classes;

type
  TfrmSettings = class(TForm)
    GruLogger: TGroupBox;
    Label8: TLabel;
    SpdOK: TSpeedButton;
    SpdCancel: TSpeedButton;
    SpnKeyPort: TSpinEdit;
    GruUP: TGroupBox;
    Label1: TLabel;
    EdtFolder: TEdit;
    SpdBrowse: TSpeedButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpdCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpdOKClick(Sender: TObject);
    procedure SpdBrowseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSettings: TfrmSettings;

implementation

{$R *.DFM}
uses untMain, ShlObj, untFileManager;

function SelectFolder(hWnd: THandle; lpTitle: string):string;
var
   lpItemID:PItemIDList;
   BrowseInfo:TBrowseInfo;
   DisplayName,TmpPath:array [0..MAX_PATH] of Char;
begin
   FillChar(BrowseInfo,SizeOf(TBrowseInfo),0);
   BrowseInfo.hwndOwner:=hWnd;
   BrowseInfo.pszDisplayName:=@DisplayName;
   BrowseInfo.lpszTitle:=PChar(lpTitle);
   BrowseInfo.ulFlags:=BIF_RETURNONLYFSDIRS;
   lpItemID:=SHBrowseForFolder(BrowseInfo);
   if lpItemID <> nil then
   begin
      ShGetPathFromIDList(lpItemID,TmpPath);
      Result:=TmpPath;
      GlobalFreePtr(lpItemID);
   end
   else
      Result:='';
end;

procedure TfrmSettings.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   Action:=caFree;
   frmSettings:=nil;
end;

procedure TfrmSettings.SpdCancelClick(Sender: TObject);
begin
   Close;
end;

procedure TfrmSettings.FormCreate(Sender: TObject);
begin
   Caption:='Settings';
   SpdBrowse.Height:=EdtFolder.Height;
   SpnKeyPort.Text:=IntToStr(frmMain.lngKeyPort);
   EdtFolder.Text:=frmMain.strDownFolder;
end;

procedure TfrmSettings.SpdOKClick(Sender: TObject);
var
   TmpPort:Longint;
begin
   TmpPort:=StrToIntDef(Trim(SpnKeyPort.Text),-1);
   if (TmpPort <= 0) or (TmpPort > 65535) then
   begin
      MessageBox(handle,'Port invalide (1 a 65535).',PChar(frmMain.Caption),MB_ICONERROR);
      Exit;
   end;
   if not MyDirectoryExists(Trim(EdtFolder.Text)) then
   begin
      MessageBox(handle,'Dossier invalide...',PChar(frmMain.Caption),MB_ICONERROR);
      Exit;
   end;
   frmMain.lngKeyPort:=TmpPort;
   frmMain.strDownFolder:=Trim(EdtFolder.Text);
   Close;
end;

procedure TfrmSettings.SpdBrowseClick(Sender: TObject);
var
   lpFolder:string;
begin
   lpFolder:=SelectFolder(Handle,'Choisir le dossier de download');
   if lpFolder <> '' then
      EdtFolder.Text:=lpFolder;
end;

end.
